// WsClient2EC2R.java
package org.objectweb.jonas.jtests.beans.wsclient;

import java.rmi.RemoteException;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.xml.rpc.ServiceException;

import org.objectweb.jonas.common.Log;
import org.objectweb.jonas.jtests.gen.xmethods.IDNamePair;
import org.objectweb.jonas.jtests.gen.xmethods.XMethodsQuery;
import org.objectweb.jonas.jtests.gen.xmethods.XMethodsQuerySoapPortType;

import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;

/**
 *
 */
public  abstract class WsClient2EC2R implements javax.ejb.EntityBean {

    static private Logger logger = null;
    javax.ejb.EntityContext ejbContext;


    XMethodsQuery service;
    XMethodsQuerySoapPortType port;

 
    public java.lang.String ejbCreate(int f1, int f2, java.lang.String f3) throws javax.ejb.CreateException{
        logger.log(BasicLevel.DEBUG, "");

        // Init here the bean fields
        setField1(f1);
	setField2(f2);
	setField3(f3);
        return null;
    }

    public void ejbPostCreate(int f1, int f2, java.lang.String f3) {
        logger.log(BasicLevel.DEBUG, "");
    }

    // ------------------------------------------------------------------
    // Persistent fields
    // 
    // ------------------------------------------------------------------
    public abstract int getField1();
    public abstract void setField1(int f1);

    public abstract int getField2();
    public abstract void setField2(int f2);

    public abstract java.lang.String getField3();
    public abstract void setField3(java.lang.String f3);

    // ------------------------------------------------------------------
    // Standard call back methods
    // ------------------------------------------------------------------

 
    public void setEntityContext(javax.ejb.EntityContext ctx) {
        if (logger == null) {
            logger = Log.getLogger("org.objectweb.jonas_tests");
        }
        logger.log(BasicLevel.DEBUG, "");
        ejbContext = ctx;
    }


    public void unsetEntityContext() {
        logger.log(BasicLevel.DEBUG, "");
        ejbContext = null;
    }

    public void ejbRemove() throws javax.ejb.RemoveException {
        logger.log(BasicLevel.DEBUG, "");
    }

 
    public void ejbLoad() {
        logger.log(BasicLevel.DEBUG, "");
    }


    public void ejbStore() {
        logger.log(BasicLevel.DEBUG, "");
    }
        

    public void ejbPassivate() {
        logger.log(BasicLevel.DEBUG, "");
    }


    public void ejbActivate() {
        logger.log(BasicLevel.DEBUG, "");
    }    

    // ------------------------------------------------------------------
    // WsClient1 implementation
    // ------------------------------------------------------------------

    public boolean lookupServiceJNDI() {
        logger.log(BasicLevel.DEBUG, "lookupServiceJNDI");
        service = null;
        try {
            InitialContext ic = new InitialContext();
            service = (XMethodsQuery) ic.lookup("ws/XMethodsService");
        } catch (NamingException ne) {
            logger.log(BasicLevel.ERROR, "looking ws/XMethodsService : " + ne.getMessage());
            return false;
        }
        return (service != null);
    }

    public boolean lookupServiceName() {
        logger.log(BasicLevel.DEBUG, "lookupServiceName");
        service = null;
        try {
            InitialContext ic = new InitialContext();
            service = (XMethodsQuery) ic.lookup("java:comp/env/service/XMethods");
        } catch (NamingException ne) {
            logger.log(BasicLevel.ERROR, "looking java:comp/env/service/XMethods : " + ne.getMessage());
            return false;
        }
        return (service != null);
    }

    public String[] getAllServiceNames() throws ServiceException, RemoteException {
        logger.log(BasicLevel.DEBUG, "getAllServiceNames");

        lookupServiceName();

        XMethodsQuerySoapPortType port = service.getXMethodsQuerySoap();
        IDNamePair[] ret = port.getAllServiceNames();
        
        String[] str = null;
        if (ret != null) {
            str = new String[ret.length];
            for (int i = 0; i < ret.length; i++) {
                str[i] = ret[i].getName();
            }
        }

        return str;
    }

}



